org.keycloak.social.openshift

## Class OpenshiftV3IdentityProvider

- java.lang.Object
- - org.keycloak.broker.provider.AbstractIdentityProvider<C>
  - - org.keycloak.broker.oidc.AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>
    - - org.keycloak.social.openshift.OpenshiftV3IdentityProvider

- All Implemented Interfaces:
    ExchangeExternalToken, ExchangeTokenToIdentityProviderToken, IdentityProvider<OpenshiftV3IdentityProviderConfig>, SocialIdentityProvider<OpenshiftV3IdentityProviderConfig>, Provider

      public class OpenshiftV3IdentityProvider
      extends AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>
      implements SocialIdentityProvider<OpenshiftV3IdentityProviderConfig>

  Identity provider for Openshift V3. Check official documentation for more details.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.keycloak.broker.oidc.AbstractOAuth2IdentityProvider

      `AbstractOAuth2IdentityProvider.Endpoint`

    - ### Nested classes/interfaces inherited from interface org.keycloak.broker.provider.IdentityProvider

      `IdentityProvider.AuthenticationCallback`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BASE_URL`

    - ### Fields inherited from class org.keycloak.broker.oidc.AbstractOAuth2IdentityProvider

      `ACCESS_DENIED, FEDERATED_REFRESH_TOKEN, FEDERATED_TOKEN_EXPIRATION, logger, mapper, OAUTH2_GRANT_TYPE_AUTHORIZATION_CODE, OAUTH2_GRANT_TYPE_REFRESH_TOKEN, OAUTH2_PARAMETER_ACCESS_TOKEN, OAUTH2_PARAMETER_CLIENT_ID, OAUTH2_PARAMETER_CLIENT_SECRET, OAUTH2_PARAMETER_CODE, OAUTH2_PARAMETER_GRANT_TYPE, OAUTH2_PARAMETER_REDIRECT_URI, OAUTH2_PARAMETER_RESPONSE_TYPE, OAUTH2_PARAMETER_SCOPE, OAUTH2_PARAMETER_STATE`

    - ### Fields inherited from class org.keycloak.broker.provider.AbstractIdentityProvider

      `ACCOUNT_LINK_URL, session`

    - ### Fields inherited from interface org.keycloak.broker.provider.IdentityProvider

      `EXTERNAL_IDENTITY_PROVIDER, FEDERATED_ACCESS_TOKEN`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OpenshiftV3IdentityProvider(KeycloakSession session, OpenshiftV3IdentityProviderConfig config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected BrokeredIdentityContext` | `doGetFederatedIdentity(String accessToken)`
    `protected BrokeredIdentityContext` | `extractIdentityFromProfile(EventBuilder event, com.fasterxml.jackson.databind.JsonNode profile)`
    `protected String` | `getDefaultScopes()`
    `protected String` | `getProfileEndpointForValidation(EventBuilder event)`
    `protected boolean` | `supportsExternalExchange()`

    - ### Methods inherited from class org.keycloak.broker.oidc.AbstractOAuth2IdentityProvider

      `asJsonNode, authenticateTokenRequest, authenticationFinished, buildUserInfoRequest, callback, createAuthorizationUrl, exchangeExternal, exchangeExternalComplete, exchangeExternalImpl, exchangeExternalUserInfoValidationOnly, exchangeFromToken, exchangeSessionToken, exchangeStoredToken, extractTokenFromResponse, generateToken, getAccessTokenResponseParameter, getConfig, getFederatedIdentity, getJsonProperty, getSignatureContext, hasExternalExchangeToken, isIssuer, performLogin, retrieveToken, validateExternalTokenThroughUserInfo`

    - ### Methods inherited from class org.keycloak.broker.provider.AbstractIdentityProvider

      `backchannelLogout, close, exchangeErrorResponse, exchangeNotLinked, exchangeNotLinkedNoStore, exchangeNotSupported, exchangeTokenExpired, exchangeUnsupportedRequiredType, export, getLinkingUrl, getMarshaller, importNewUser, keycloakInitiatedBrowserLogout, preprocessFederatedIdentity, updateBrokeredUser`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.keycloak.broker.provider.IdentityProvider

      `authenticationFinished, backchannelLogout, callback, export, getMarshaller, importNewUser, keycloakInitiatedBrowserLogout, performLogin, preprocessFederatedIdentity, retrieveToken, updateBrokeredUser`

    - ### Methods inherited from interface org.keycloak.provider.Provider

      `close`

- - ### Field Detail

    - #### BASE_URL

          public static final String BASE_URL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### OpenshiftV3IdentityProvider

          public OpenshiftV3IdentityProvider(KeycloakSession session,
                                             OpenshiftV3IdentityProviderConfig config)

  - ### Method Detail

    - #### getDefaultScopes

          protected String getDefaultScopes()

      Specified by:
        `getDefaultScopes` in class `AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>`

    - #### doGetFederatedIdentity

          protected BrokeredIdentityContext doGetFederatedIdentity(String accessToken)

      Overrides:
        `doGetFederatedIdentity` in class `AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>`

    - #### supportsExternalExchange

          protected boolean supportsExternalExchange()

      Overrides:
        `supportsExternalExchange` in class `AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>`

    - #### getProfileEndpointForValidation

          protected String getProfileEndpointForValidation(EventBuilder event)

      Overrides:
        `getProfileEndpointForValidation` in class `AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>`

    - #### extractIdentityFromProfile

          protected BrokeredIdentityContext extractIdentityFromProfile(EventBuilder event,
                                                                       com.fasterxml.jackson.databind.JsonNode profile)

      Overrides:
        `extractIdentityFromProfile` in class `AbstractOAuth2IdentityProvider<OpenshiftV3IdentityProviderConfig>`

Copyright © 2021 JBoss by Red Hat. All rights reserved.